'use strict';
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tar = __importStar(require("tar"));
var path = __importStar(require("path"));
var http = __importStar(require("http"));
var fs = __importStar(require("fs"));
var progress_1 = __importDefault(require("progress"));
var utils_1 = require("./utils");
var Installer = /** @class */ (function () {
    function Installer() {
    }
    Installer.prototype.download = function (config, callback) {
        console.log("Started downloading Dynamodb-local. Process may take few minutes.");
        console.log("Installation path is: " + config.install_path + ".");
        http.get(config.download_url, function (response) {
            var len = parseInt(response.headers['content-length'] || '0', 10);
            var bar = new progress_1.default('Downloading dynamodb-local [:bar] :percent :etas', {
                complete: '=',
                incomplete: ' ',
                width: 40,
                total: len
            });
            if (200 != response.statusCode) {
                throw new Error('Error getting DynamoDb local latest tar.gz location ' + response.headers.location + ': ' + response.statusCode);
            }
            response
                .pipe(tar.x({
                C: config.install_path // alias for cwd:'some-dir', also ok
            }))
                .on('data', function (chunk) {
                bar.tick(chunk.length);
            })
                .on('end', function () {
                callback("\n Installation complete!");
            })
                .on('error', function (err) {
                throw new Error("Error in downloading Dynamodb local " + err);
            });
        })
            .on('error', function (err) {
            throw new Error("Error in downloading Dynamodb local " + err);
        });
    };
    ;
    Installer.prototype.install = function (config, callback) {
        var utils = new utils_1.Utils();
        config.install_path = utils.absPath(config.install_path);
        try {
            if (fs.existsSync(path.join(config.install_path, config.jar))) {
                callback("Dynamodb is already installed on path!");
            }
            else {
                utils.createDir(config.install_path);
                this.download(config, callback);
            }
        }
        catch (e) { }
    };
    ;
    return Installer;
}());
exports.Installer = Installer;
//# sourceMappingURL=installer.js.map